local utils = require("utils")

local logChance = GetModConfigData("logChance", KnownModIndex:GetModActualName("(JEM) More Drops DS"))
local egg_chance = GetModConfigData("eggChance", KnownModIndex:GetModActualName("(JEM) More Drops DS"))
local coconut_chance = GetModConfigData("coconutChance", KnownModIndex:GetModActualName("(JEM) More Drops DS"))
local burr_chance = GetModConfigData("burrChance", KnownModIndex:GetModActualName("(JEM) More Drops DS"))
local tea_chance = GetModConfigData("teaChance", KnownModIndex:GetModActualName("(JEM) More Drops DS"))
--local bambooChance = GetModConfigData("bambooChance", KnownModIndex:GetModActualName("(JEM) More Drops DS"))

local function ImproveTree(inst)
	--Do these when the tree is fully chopped
  local seed_chance  = GetModConfigData("treeseedchance", KnownModIndex:GetModActualName("(JEM) More Drops DS"))

  
	local oldonfinish = inst.components.workable.onfinish
	inst.components.workable:SetOnFinishCallback(function(inst, chopper)
		--Drop base logs
    if utils.LootRandom(logChance) then
		utils.DoTimes(GetModConfigData("extralogs", KnownModIndex:GetModActualName("(JEM) More Drops DS")), inst.components.lootdropper.SpawnLootPrefab, inst.components.lootdropper, "log")
	end	
		--Have a chance to spawn the appropriate seed item
		if inst.name == "Evergreen" and inst.components.growable.stage ~= 1 then
			if utils.DropLootRandom(inst, "pinecone", seed_chance) then print("Dropped seed") end
		elseif inst.name == "Birchnut Tree" and inst.components.growable.stage ~= 1 then
			if utils.DropLootRandom(inst, "acorn", seed_chance) then print("Dropped seed") end
		elseif inst.name == "Twiggy Tree" and inst.components.growable.stage ~= 1 then
			if utils.DropLootRandom(inst, "twiggy_nut", seed_chance) then print("Dropped seed") end
			
		--SW Trees
		elseif inst.name == "Jungle Tree" and inst.components.growable.stage ~= 1 then
			if utils.DropLootRandom(inst, "jungletreeseed", seed_chance) then print("Dropped seed") end
		elseif inst.name == "Palm Tree" and inst.components.growable.stage ~= 1 then
			if utils.DropLootRandom(inst, "coconut", seed_chance) then print("Dropped seed") end
			-- if you try to use anything other than seed_chance here then the game crashes. IDK why. coconut_seed_chance isn't working.
			
		--Ham Trees	
		--elseif inst.name == "Rainforest Tree" and inst.components.growable.stage ~= 1 then
		--	if utils.DropLootRandom(inst, "burr", burr_seed_chance) then print("Dropped seed") end
		elseif inst.name == "Tea Tree" and inst.components.growable.stage ~= 1 then
			if utils.DropLootRandom(inst, "teatree_nut", seed_chance) then print("Dropped seed") end
	end
	
			--eggs
			--	if utils.DropLootRandom(inst, "bird_egg", egg_chance) then print("Dropped seed") end
			--	if utils.DropLootRandom(inst, "bird_egg", egg_chance) then print("Dropped seed") end
	
			--bamboo
	--	if inst.name == "Bamboo Patch" and utils.LootRandom(bambooChance) then 
	--		utils.DoTimes(GetModConfigData("bambooAmount", KnownModIndex:GetModActualName("(JEM) More Drops DS")), inst.components.lootdropper.SpawnLootPrefab, inst.components.lootdropper, "bamboo"), print("Dropped Bamboo")
	--end
	
	
		--Spawn extra logs for tall trees
		if inst.components.growable.stage == 3 and utils.LootRandom(logChance) then
			utils.DoTimes(GetModConfigData("extralogstall", KnownModIndex:GetModActualName("(JEM) More Drops DS")), inst.components.lootdropper.SpawnLootPrefab, inst.components.lootdropper, "log")
	end
	
		oldonfinish(inst, chopper)
	end)
end

return ImproveTree